#include "panrcp.h"

/* local values */
MOBJECT new_password;
MOBJECT screen;

#define min(a,b) (a<b?a:b)
void newpassword_t(void *param)
{
 HackIt hHackIt = *((HackIt *)param);
 Pan_PassHack pTemp;
 uint8 logkey[8],oldcrpw[17],newcrpw[17];
 char name[129];
 char str[512];
 int err,l,i;

 sprintUnicodeName(name,hHackIt.pPassHack.userCN+6,128);

 err=GUI_Pan_NCP_connect(0);
 if (err) {
           strcpy(str, "An error occured : ");
           strcat(str,Pan_error(err));
           MSListAddItem(rlist,str,NULL);
          }
 else
  {
   err=getlogkey(logkey);
   if (err) {
             strcpy(str, "An error occured : ");
             strcat(str,Pan_error(err));
             MSListAddItem(rlist,str,NULL);
            }
   else
    {
     /*** the trick ***/
     for(i=0;i<16;i++) oldcrpw[i]=hHackIt.pPassHack.hash[i];
     err=Pan_Challenge_Response(&(hHackIt.pPassHack),TRUE,logkey,logkey);
     if (err) {
               strcpy(str, "An error occured : ");
               strcat(str,Pan_error(err));
               MSListAddItem(rlist,str,NULL);
              }
     else
      {
       /*** generates new hash***/
       pTemp.objectID=hHackIt.pPassHack.objectID;
       pTemp.pwlen=strlen(hHackIt.str); /* new_pass stored in hHackIt.str */
       strcpy(pTemp.pw_first,hHackIt.str);
       pTemp.pw_current[0]='\0';
       pTemp.pw_last[0]='\0'; /* NULL values are checked in Pandora API*/
       pTemp.key_space[0]='\0';
       err=Pan_Hash_Gen(&pTemp);
       if (err) {
                 strcpy(str, "An error occured : ");
                 strcat(str,Pan_error(err));
                 MSListAddItem(rlist,str,NULL);
                }
       else
        {
         for(i=0;i<16;i++) newcrpw[i]=pTemp.hash[i];
         /*** where the magic happens ***/
         Pan_3hash_cipher(oldcrpw,newcrpw,newcrpw);
         /* l is the lengh of the cleartext password transfered in a ciphered */
         /* fashion, but the server who knows the oldhash is able to retreive */
         /* the real lengh of the new password */
         l=((( min(63,strlen(hHackIt.str))^oldcrpw[0]^oldcrpw[1] )&0x7f)|0x40);
         err=setpwcrypt(logkey,hHackIt.pPassHack.bind,name,newcrpw,l);
         if (err) {
                   strcpy(str, "An error occured : ");
                   strcat(str,Pan_error(err));
                   MSListAddItem(rlist,str,NULL);
                  }
         else MSListAddItem(rlist,"Password was changed",NULL);
        }
      }
    }
  }
 free((HackIt *)param);
}

void QuitNewPassword(MOBJECT p, void *s, void *v)
{
 MShellDestroy(p);
}

void NewPassword(MOBJECT p, void *s, void *v)
{
 HackIt *_hHackIt;
#ifdef UNIX
 pthread_t pan_thread;
#endif

 _hHackIt=(HackIt *)calloc(1,sizeof(HackIt));

 strncpy(_hHackIt->str,MEditValue(new_password),MAXPASSLEN);

 MShellDestroy(p);

 while (!(_smutex_available(&attacking)));
 _smutex_request(&attacking);
 PassHack_to_PassHack(&(_hHackIt->pPassHack),&pPassHack);
 _smutex_release(&attacking);
#if !defined UNIX
 _beginthread(newpassword_t, NULL, 32768, (void *)_hHackIt);
#else
 pthread_create(&pan_thread,NULL,(void *)newpassword_t,(void *)_hHackIt);
#endif
}

void SetNewPassword(MOBJECT o, void *o_data, void *a_data)
{
 MOBJECT form_id;
 MOBJECT label;

 char temp[257];

 screen = MCreateShell("Change password", SF_MODAL);
 MObjectSetBackgroundRGB(screen, 56, 112, 112);

 form_id = MCreateRowForm(screen);
 MObjectSetBackgroundRGB(form_id, 56, 112, 112);

 sprintUnicodeName(temp,pPassHack.userCN,128);
 strcat(temp,".");
 sprintUnicodeName(temp+strlen(temp),pPassHack.userOU,40);
 label = MCreateLabel(form_id, temp, FIXED_SMALL);
 MRightAttach(label, F_ATT_NONE, 3, NULL);
 MObjectSetBackgroundRGB(label, 56, 112, 112);
 MObjectSetForegroundRGB(label, 255, 255, 255);

 label = MCreateLabel(form_id, "Give a password", FIXED_SMALL);
 MRightAttach(label, F_ATT_NONE, 3, NULL);
 MObjectSetBackgroundRGB(label, 56, 112, 112);
 MObjectSetForegroundRGB(label, 255, 255, 255);

 new_password = MCreateClippedEdit(form_id, "", MAXPASSLEN, 20, FIXED_SMALL);
 MRightAttach(new_password, F_ATT_NONE, 3, NULL);
 MObjectSetBackgroundRGB(new_password, 56, 112, 112);
 MObjectSetForegroundRGB(new_password, 192, 176, 160);

 form_id = MCreateColForm(screen);
 MObjectSetBackgroundRGB(form_id, 56, 112, 112);

 label = MCreatePButton(form_id, "Change", FIXED_SMALL);
 MPButtonSetCallback(label, NewPassword, 0L);

 label = MCreatePButton(form_id, "Cancel", FIXED_SMALL);
 MPButtonSetCallback(label, QuitNewPassword, 0L);

 MShellRealize(screen);
}

void ChangePassword(MOBJECT o, void *o_data, void *a_data)
{
 if (!pPassHack.objectID)
  {
   MMessageDialog("", "o O Double click on a user to select first O o", "Ok", NULL);
   return;
  }
 SetNewPassword(o,o_data,a_data);
}